<?php

function resposta($status, $mensagem, $dados)
{
  header("HTTP/1.1 " . $status);

  $resposta['status'] = $status;
  $resposta['mensagem'] = $mensagem;
  $resposta['dados'] = $dados;

  $json_resposta = json_encode($resposta);

  echo $json_resposta;
  return $status;
}

function salvar($dados)
{
  $nomeArquivo = './dados.json';
  $dadosGravados = json_decode(file_get_contents($nomeArquivo), true);
  $arquivo = fopen($nomeArquivo, 'w');

  // Incrementa as informações enviadas com o que já havia gravado
  array_push($dadosGravados, $dados);

  if (!fwrite($arquivo, json_encode($dadosGravados))) {
    resposta(300, "Falha ao salvar os dados da requisição.", NULL);
  }

  fclose($arquivo);
}

function requisicao($metodo, $body, $parametros)
{
  switch ($metodo) {
    case 'POST':
      if (($parametros[0] == 'pix' && empty($parametros[1])) || (empty($parametros[0]))) {
        salvar($body);
        resposta(200, "Requisição realizada com sucesso!", NULL);
      } else {
        resposta(400, "Ocorreu um erro ao validar os parâmetros.", NULL);
      }
      break;
  }
}

// Obtém o método HTTP, body e parâmetros da requisição
$metodo = $_SERVER['REQUEST_METHOD'];
$parametros = explode('/', trim($_SERVER['REQUEST_URI'], '/'));
$body = json_decode(file_get_contents('php://input'), true);

try {
  requisicao($metodo, $body, $parametros);
} catch (Exception $e) {
  resposta(400, $e->getMessage(), NULL);
}
